#include <optix_world.h>
#include <math_constants.h>
#include "types.cuh"
#include "common.cuh"

using namespace optix;

/// State and constants
rtDeclareVariable(RayPayload, payload, rtPayload, );
rtDeclareVariable(Ray, ray, rtCurrentRay,);
rtDeclareVariable(float,  scene_scale, , );

/// Attributes
rtDeclareVariable(float3, p, attribute p, );
rtDeclareVariable(float3, ns, attribute ns, );
rtDeclareVariable(float3, ng, attribute ng, );

RT_PROGRAM void ray_hit_closest() {
    float t = sqrt(squared_norm(p - ray.origin) / squared_norm(ray.direction));
    t /= 2.5f * scene_scale;
    payload.result.x = t;
    payload.result.y = t;
    payload.result.z = t;
}
