#include <optix_world.h>
#include <math_constants.h>
#include "common.cuh"

using namespace optix;

rtDeclareVariable(uint1, launch_index, rtLaunchIndex, );

/// Output buffer
rtBuffer<float> output;

extern "C" {
__device__ void test_computation(float x, float *result);
__device__ void test_computation_d(float x, float grad_of_output, float *result);
}


__device__ float call_test_function(float x) {
    float result;

    // Assume objective is:  0.5 * sum(res ^ 2)
    test_computation(x, &result);
    float grad_of_output = result;

    test_computation_d(x, grad_of_output, &result);
    return result;
}


RT_PROGRAM void ray_gen() {
    // output[launch_index.x] = 1.f * launch_index.x;
    // output[launch_index.x] = call_test_function(
    //     2.f * math::Pi * launch_index.x / 100.f);
    output[launch_index.x] = call_test_function(launch_index.x / 100.f);
    // output[launch_index.x] = call_test_function(1.f);
    // output[launch_index.x] = call_test_function(0.f);
}
