import os
import numpy as np

from config import OUTPUT_DIR
from volume_utils import write_binary_grid3d

generate_density = True

if generate_density:
    if True:
        # Gray density volume with a specific resolution
        # This is to start smoke plume density optimization.
        # Resolution of the smoke plume volume: 111x222x112
        # res = (55, 111, 55)
        res = (111, 222, 112)
        constant_value = 0.018
        values = constant_value * np.ones(res)
        name = 'density-grid-res-{}-{}-{}-value-{}'.format(*res, constant_value)
    else:
        res = 3
        constant_value = 10.0
        values = constant_value * np.ones(shape=(res, res, res))
        name = 'constant-side-{}-value-{}'.format(res, constant_value)

        # res = 3
        # values = np.array([1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
        #                    1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1], dtype=np.float32)
        # values = np.reshape(values, (res, res, res))

        # res = 3
        # values = np.random.rand(res, res, res) ** 10
        # name = 'noise-side-{}'.format(res)

    output_dir = os.path.join(OUTPUT_DIR, 'generated_volumes')
    os.makedirs(output_dir, exist_ok=True)
    fname = os.path.join(output_dir, name + '.vol')
    write_binary_grid3d(fname, values)
    print('Volume data written to', fname)

else:
    if False:
        # Gray RGB volume with a specific resolution
        # This is to start albedo optimization.
        res = (256, 64, 256)
        values = np.zeros((*res, 3))
        constant = 0.75
        for i in range(values.shape[-1]):
            values[:, :, :, i] = constant
        name = 'albedo-grid-res-{}-{}-{}-value-{}'.format(*res, constant)
    else:
        # Gradient volume
        res = 8
        grad_values = np.ones(shape=(res, res, res), dtype=np.float32)
        # x = np.linspace(0.0, 1.0, res)
        # grad_values *= x * x

        values = np.zeros((res, res, res, 3))
        # values = np.random.rand(res, res, res, 3)* 0.0
        # values[:, :, :, 0] = grad_values
        # values[:, :, :, 1] = 1 - grad_values
        for i in range(values.shape[-1]):
            values[:, :, :, i] = 0.75 * grad_values
        name = 'albedo-grid-side-{}'.format(res)

    # values[:, :, :, 0] = 0.0
    # values[:, :, :, 1] = 1.0
    # values[:, :, :, 2] = 0.0
    # name = 'green-albedo-grid'

    output_dir = os.path.join(OUTPUT_DIR, 'generated_volumes')
    os.makedirs(output_dir, exist_ok=True)
    fname = os.path.join(output_dir, name + '.vol')
    write_binary_grid3d(fname, values)
    print('Volume data written to', fname)
