import os
import numpy

import test_performance_radiative_backprop as prb
from test_performance_radiative_backprop import ResultKey, make_key
from benchmark_utils import parameters_expand_wildcard


def test01_parameters_expand_wildcard():
    # Single parameter
    initial = ResultKey(scene_name='cbox-rgb', resolution_x=256, resolution_y=256, spp=None, max_depth=6)
    expected = set([
        ResultKey(scene_name='cbox-rgb', resolution_x=256, resolution_y=256, spp=spp, max_depth=6)
        for spp in prb.SPP
    ])
    result = parameters_expand_wildcard(initial)
    assert isinstance(result, set)
    assert result == expected

    # Two parameters
    initial = ResultKey(scene_name='cbox-rgb', resolution_x=256, resolution_y=256, spp=None, max_depth=None)
    expected = set(sum([
        [ResultKey(scene_name='cbox-rgb', resolution_x=256, resolution_y=256,
                   spp=spp, max_depth=md)
         for spp in prb.SPP]
        for md in prb.MAX_DEPTH
    ], []))
    result = parameters_expand_wildcard(initial)
    assert isinstance(result, set)
    assert result == expected
